package com.reactlibrary;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import androidx.localbroadcastmanager.content.LocalBroadcastManager;

import com.facebook.react.bridge.Arguments;
import com.facebook.react.bridge.Promise;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactMethod;
import com.facebook.react.bridge.WritableMap;
import com.facebook.react.modules.core.DeviceEventManagerModule;

public class RNKeyboardTrackerModule extends ReactContextBaseJavaModule {

  private ReactApplicationContext mReactContext;
  private KeyboardTrackerReceiver mKeyboardTrackerReceiver;

  public RNKeyboardTrackerModule(ReactApplicationContext reactContext) {
    super(reactContext);
    this.mReactContext = reactContext;
    this.mKeyboardTrackerReceiver = new KeyboardTrackerReceiver();
    LocalBroadcastManager localBroadcastManager = LocalBroadcastManager.getInstance(reactContext);
    localBroadcastManager.registerReceiver(mKeyboardTrackerReceiver, new IntentFilter("keyboardTrackerEvent"));
  }

  @Override
  public String getName() {
    return "RNKeyboardTracker";
  }

  public class KeyboardTrackerReceiver extends BroadcastReceiver {
    @Override
    public void onReceive(Context context, Intent intent) {
      String jsonString = intent.getStringExtra("jsonString");
      sendEvent(jsonString);
    }
  }

  private void sendEvent(String jsonString){
    WritableMap map = Arguments.createMap();
    map.putString("jsonString", jsonString);

    this.mReactContext.getJSModule(DeviceEventManagerModule.RCTDeviceEventEmitter.class)
            .emit("customTracker", map);
  }

  @ReactMethod
  public void startService(Promise promise) {
    try{
      Intent intent = new Intent();
      intent.setClass(this.mReactContext, KeyboardService.class);
      mReactContext.startService(intent);
      WritableMap map = Arguments.createMap();
      map.putString("fromPromise", "startedService");
      promise.resolve(map);
    }catch (Exception e){
      promise.reject(e);
    }
  }

   @ReactMethod
  public void makeError()
  {
    
    try{

      String name = "dsad";
      int sd = 13;
      sd = Integer.parseInt(name);
    }catch(NullPointerException ws){

    }
    

}